# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional, Union

from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr


class NumberConfigField(BaseModel):
  """
    NumberConfigField
    """
  default_value: Optional[Union[StrictFloat, StrictInt]] = None
  description: Optional[StrictStr] = None
  key: StrictStr = Field(..., description='The key of the field in the config.')
  max_value: Optional[Union[StrictFloat, StrictInt]] = None
  min_value: Optional[Union[StrictFloat, StrictInt]] = None
  name: StrictStr = Field(..., description='The name of the field.')
  type: Optional[StrictStr] = 'number'
  value: Optional[Union[StrictFloat, StrictInt]] = Field(...)
  __properties = [
    'default_value', 'description', 'key', 'max_value', 'min_value', 'name', 'type', 'value'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> NumberConfigField:
    """Create an instance of NumberConfigField from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if default_value (nullable) is None
    # and __fields_set__ contains the field
    if self.default_value is None and 'default_value' in self.__fields_set__:
      _dict['default_value'] = None

    # set to None if description (nullable) is None
    # and __fields_set__ contains the field
    if self.description is None and 'description' in self.__fields_set__:
      _dict['description'] = None

    # set to None if max_value (nullable) is None
    # and __fields_set__ contains the field
    if self.max_value is None and 'max_value' in self.__fields_set__:
      _dict['max_value'] = None

    # set to None if min_value (nullable) is None
    # and __fields_set__ contains the field
    if self.min_value is None and 'min_value' in self.__fields_set__:
      _dict['min_value'] = None

    # set to None if value (nullable) is None
    # and __fields_set__ contains the field
    if self.value is None and 'value' in self.__fields_set__:
      _dict['value'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> NumberConfigField:
    """Create an instance of NumberConfigField from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return NumberConfigField.parse_obj(obj)

    _obj = NumberConfigField.parse_obj(
      {
        'default_value': obj.get('default_value'),
        'description': obj.get('description'),
        'key': obj.get('key'),
        'max_value': obj.get('max_value'),
        'min_value': obj.get('min_value'),
        'name': obj.get('name'),
        'type': obj.get('type') if obj.get('type') is not None else 'number',
        'value': obj.get('value')
      }
    )
    return _obj
