# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from getopenpay.models.object_name import ObjectName
from getopenpay.models.payment_processor_name import PaymentProcessorName
from pydantic import BaseModel, Field, StrictBool, StrictStr


class PaymentMethodMappingExternal(BaseModel):
  """
    PaymentMethodMappingExternal
    """
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  id: StrictStr = Field(..., description='Unique identifier of the payment method mapping.')
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  object: Optional[ObjectName] = None
  payment_method_id: StrictStr = Field(..., description='External id for payment method')
  processor_id: StrictStr = Field(..., description='External id for processor')
  processor_name: PaymentProcessorName = Field(..., description='Name of the payment processor.')
  their_payment_method_id: StrictStr = Field(
    ..., description="The payment method identifier from the processor's perspective."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  __properties = [
    'created_at', 'id', 'is_deleted', 'object', 'payment_method_id', 'processor_id',
    'processor_name', 'their_payment_method_id', 'updated_at'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> PaymentMethodMappingExternal:
    """Create an instance of PaymentMethodMappingExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> PaymentMethodMappingExternal:
    """Create an instance of PaymentMethodMappingExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return PaymentMethodMappingExternal.parse_obj(obj)

    _obj = PaymentMethodMappingExternal.parse_obj(
      {
        'created_at': obj.get('created_at'),
        'id': obj.get('id'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'object': obj.get('object'),
        'payment_method_id': obj.get('payment_method_id'),
        'processor_id': obj.get('processor_id'),
        'processor_name': obj.get('processor_name'),
        'their_payment_method_id': obj.get('their_payment_method_id'),
        'updated_at': obj.get('updated_at')
      }
    )
    return _obj
