# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictStr


class PortalSessionExternal(BaseModel):
  """
    PortalSessionExternal
    """
  account_id: StrictStr = Field(..., description='Unique identifier for the account.')
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  customer_id: StrictStr = Field(..., description='The ID of an existing customer.')
  id: StrictStr = Field(..., description='The ID of the portal session.')
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  object: Optional[ObjectName] = None
  return_url: StrictStr = Field(
    ...,
    description=
    "The default URL to redirect customers to when they click on the portal\"s link to return to your website."
  )
  token: StrictStr = Field(
    ...,
    description=
    'The short-lived token of the session that gives customers access to the customer portal.'
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  url: StrictStr = Field(
    ...,
    description=
    'The short-lived URL of the session that gives customers access to the customer portal.'
  )
  __properties = [
    'account_id', 'created_at', 'customer_id', 'id', 'is_deleted', 'object', 'return_url', 'token',
    'updated_at', 'url'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> PortalSessionExternal:
    """Create an instance of PortalSessionExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> PortalSessionExternal:
    """Create an instance of PortalSessionExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return PortalSessionExternal.parse_obj(obj)

    _obj = PortalSessionExternal.parse_obj(
      {
        'account_id': obj.get('account_id'),
        'created_at': obj.get('created_at'),
        'customer_id': obj.get('customer_id'),
        'id': obj.get('id'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'object': obj.get('object'),
        'return_url': obj.get('return_url'),
        'token': obj.get('token'),
        'updated_at': obj.get('updated_at'),
        'url': obj.get('url')
      }
    )
    return _obj
