# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.object_name import ObjectName
from getopenpay.models.refund_reason_enum import RefundReasonEnum
from getopenpay.models.refund_status_enum import RefundStatusEnum
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr


class RefundExternal(BaseModel):
  """
    RefundExternal
    """
  amount_atom: StrictInt = Field(..., description='amount_atom that you want to refund.')
  attempt_error_message: Optional[StrictStr] = None
  charge_id: StrictStr = Field(..., description='Unique Identifier of the charge.')
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  currency: Optional[CurrencyEnum] = Field(
    None, description='Three-letter ISO currency code, in lowercase.'
  )
  id: StrictStr = Field(..., description='Unique Identifier of the refund.')
  invoice_id: StrictStr = Field(..., description='Invoice id to which the refund is attached.')
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  object: Optional[ObjectName] = None
  payment_intent_id: StrictStr = Field(..., description='Unique Identifier of the payment_intent.')
  reason: RefundReasonEnum = Field(..., description='Reason of the refund.')
  status: RefundStatusEnum = Field(..., description='Status of the refund.')
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  __properties = [
    'amount_atom', 'attempt_error_message', 'charge_id', 'created_at', 'currency', 'id',
    'invoice_id', 'is_deleted', 'object', 'payment_intent_id', 'reason', 'status', 'updated_at'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> RefundExternal:
    """Create an instance of RefundExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if attempt_error_message (nullable) is None
    # and __fields_set__ contains the field
    if self.attempt_error_message is None and 'attempt_error_message' in self.__fields_set__:
      _dict['attempt_error_message'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> RefundExternal:
    """Create an instance of RefundExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return RefundExternal.parse_obj(obj)

    _obj = RefundExternal.parse_obj(
      {
        'amount_atom': obj.get('amount_atom'),
        'attempt_error_message': obj.get('attempt_error_message'),
        'charge_id': obj.get('charge_id'),
        'created_at': obj.get('created_at'),
        'currency': obj.get('currency'),
        'id': obj.get('id'),
        'invoice_id': obj.get('invoice_id'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'object': obj.get('object'),
        'payment_intent_id': obj.get('payment_intent_id'),
        'reason': obj.get('reason'),
        'status': obj.get('status'),
        'updated_at': obj.get('updated_at')
      }
    )
    return _obj
