# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional

from getopenpay.models.object_name import ObjectName
from getopenpay.models.tax_integration_api_name import TaxIntegrationApiName
from pydantic import BaseModel, Field, StrictBool, StrictStr


class TaxIntegrationExternal(BaseModel):
  """
    TaxIntegrationExternal
    """
  accounting_tz: StrictStr = Field(
    ...,
    description=
    'The timezone name for the accounting timezone (see pytz.all_timezones for a full list)'
  )
  api_keys: Dict[str, Any] = Field(
    ..., description='These keys will allow to authenticate API requests to the tax processor.'
  )
  api_name: TaxIntegrationApiName = Field(
    ..., description='The name of the API used for the tax integration.'
  )
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  id: StrictStr = Field(..., description='Unique Identifier of the tax integration.')
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  object: Optional[ObjectName] = None
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  __properties = [
    'accounting_tz', 'api_keys', 'api_name', 'created_at', 'id', 'is_deleted', 'object',
    'updated_at'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> TaxIntegrationExternal:
    """Create an instance of TaxIntegrationExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> TaxIntegrationExternal:
    """Create an instance of TaxIntegrationExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return TaxIntegrationExternal.parse_obj(obj)

    _obj = TaxIntegrationExternal.parse_obj(
      {
        'accounting_tz': obj.get('accounting_tz'),
        'api_keys': obj.get('api_keys'),
        'api_name': obj.get('api_name'),
        'created_at': obj.get('created_at'),
        'id': obj.get('id'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'object': obj.get('object'),
        'updated_at': obj.get('updated_at')
      }
    )
    return _obj
